/* Moygl.js. Code written 20 Jan 2014 By Nick Stokes. See post at
http://moyhu.blogspot.co.uk/2014/01/generic-code-for-webgl-earth-data.html  */
// Misc Functions:

function PxGrid(m,n,P){//make links and latlon set
	var i,I,j,k,m,n,n,p,P,q,y,dx,dy,u,v,x,y,z,M=Math;
	if(m==1)m=M.round(M.sqrt(n/2))*2;
	Pxgr=P;
	n/=m;
	I=n-n%2;
	dx=360/m;dy=180/I;
	y=-90; if(I==n)y+=dy/2;
	k=0;
	if(P.palette.length<4)P.palette=Pxpal;
	P.cols=PxCol(P.nodes,P);
	P.m.push(PxCol(P.m[3],P)); k=P.m;//making color key
	p=P.links=[];z=P.nodes=[];
	P.type=TRIANGLE_STRIP; k=0;
	for(j=0;j<=I;j++){//lats
		x=-180;
		for(i=0;i<m;i++){
			z.push(y,x); x+=dx;
			if(j<n)p.push(k,k+m);
			k++;
		}		
		p.push(k-m,k); y+=dy;
		if(j==n)break;
	}
	PxKey(P);
}
function PxCol(z,P){//onverts grid values into colors. Also used for key
		var i,j,k=0,a=0,b=0,mn,sd,N,u,v,w,P;
		N=z.length;
		if(!P.m){
		for(i=0;i<N;i++){u=z[i]; if(isFinite(u)){
		a+=u;b+=u*u;k++;
		}
		}
		mn=a/k; sd=Math.sqrt(b/k-mn*mn);u=[];v=[];
		for(i= -5;i<6;i++){a=(mn+i*sd/2).toPrecision(2);
		u.push(a); 		v.push(Number(a));
		}
		P.m=[mn,sd,u,v];//u labels, v corresp numbers
		}
		k=(P.palette.length/3-1)/2;w=[];
		a=0;
		for(i=0;i<N;i++){
			u=Math.exp((z[i]-P.m[0])/P.m[1]); w[i]=v=(u-1)/(u+1);
			if(isFinite(v))a=Math.max(v,-v,a)		
		}
		P.m.push(a)// expansion factor to use almost all range
		// ie keep mid at mean, expand as much as poss
		a=P.m[4];// don't change a for key calc
		for(i=0;i<N;i++){w[i]=Math.round(k*(w[i]/a+1))}
		return w;
	}
function PxKey(P){
	var i,j,k,m,p,q,s,u;
	p=P.palette;k=p.length;q=Pxcn; m=k/3-1;
	q.clearRect(0,0,50,600);
	for(i=0;i<k;i+=3){ 
	s="#";
	for(j=0;j<3;j++){
	u=Math.round(p[i+j]*m);
	if(u<16)s+="0";
	s+=u.toString(16);}
	q.fillStyle=s;
	j=i*2/3
	q.fillRect(2,550-j,10,2);
	}
	p=P.m;
	q.fillStyle="black"
	for(i=0;i<11;i++){ 
	  q.fillText(p[2][i],15,550-2*p[6][i])
	}
	}

function Pxpix2z(event){
// Takes click pixels, adjusts relative to canvas top left, and de-scales to place on unit sphere
	     var X=event.pageX, Y=event.pageY, e=Pxcanvas;
	     do{X-=e.offsetLeft;Y-=e.offsetTop;  }
	     while(e = e.offsetParent)
			 X= (2.*X/PxD[0]-1.)/Pxzoom; 
	     Y= (1.-2.*Y/PxD[1])/Pxzoom; 
	     return [X,Y,-Math.sqrt(1-X*X-Y*Y)]
	   }
// draw scene
function PxDraw(){
	var i,j,k=0,m,q,p,pg,r,s,u,gl=Pxgl,v=[], g=[gl.POINTS,gl.LINES,gl.TRIANGLES,gl.LINE_STRIP,gl.TRIANGLE_STRIP,gl.LINE_LOOP,gl.TRIANGLE_FAN],w=[[3,12,0],[3,28,0],[4,28,12]];
	gl.enable(gl.DEPTH_TEST);
	// Make rotation matrix as 9-vector
		for(i=0;i<3;i++){  v[i]=PxaM[i].concat();
		for(j=0;j<9;j++){
		if(i<2 & j%3!=2) v[i][j] *= Pxzoom;;
		}}
	for(i=0;i<Pxno;i++){//Draw objects
		p=Pxob[i]; pg=p.prog;
	  gl.useProgram(pg); j=p.cols?1:0; //j=1 if color shading
		q=["aP"+i]; if(j) q.push("aC"+i);
		setAtt(gl, pg, q, w[j], p.verts)
		u = gl.getUniformLocation(pg, "aM"+i); // Rotation matrix		
		// No rotation for obj 0 (disc at zero depth)
		gl.uniformMatrix3fv( u, false, new Float32Array(v[p.r]) );
		if(!j)	 {// No shading - pass color
			u=gl.getUniformLocation(pg, "aC"+i);// Uniform color
			s=p.palette.concat([1]);
			if(q.length==1 & s.length==4)gl.uniform4fv(u, s);
			u=gl.getUniformLocation(pg, "aS"+i);// Uniform color
			gl.uniform1f(u, p.size);
		}
		gl.drawArrays(g[p.type], 0, p.num); //Draw the object
	}
}
/* Create buffer with vertexdata arr[[],[]] (coords + (maybe)cols   */
function setAtt(gl, prog,a, r, arr) {
var attr,i,j;
	gl.bindBuffer(gl.ARRAY_BUFFER, gl.createBuffer());
	gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(arr),
	gl.STATIC_DRAW);
	for(i=0;i<a.length;i++){// vertex coords and then cols
	attr=gl.getAttribLocation(prog, a[i]);
	gl.enableVertexAttribArray(attr);
	gl.vertexAttribPointer(attr, r[0], gl.FLOAT, false, r[1],r[2]);
	r=[4,28,12];
}
}
function shadProg(gl, sh) {// Compile and attach shaders
	var i, prog = gl.createProgram();
	for(i=0;i<2;i++){
		var s = gl.createShader([gl.VERTEX_SHADER,gl.FRAGMENT_SHADER][i]);
		gl.shaderSource(s, sh[i]);
		gl.compileShader(s);
		if (!gl.getShaderParameter(s, gl.COMPILE_STATUS)) {
			throw "Could not compile shader"+i+"\n\n"+gl.getShaderInfoLog(s);
		}
		gl.attachShader(prog, s);
	};
	gl.linkProgram(prog);
	if (!gl.getProgramParameter(prog, gl.LINK_STATUS)) {
		throw "Could not link shaders";
	}
	return prog;
}
function PxGeo(){//needs Pxob but not gl
// Modifies data to produce vertex arrays with color,
// as required by WebGL. Implements lookups
	var a,b,c,d,i,ii,j,k,m,M=Math,o,p,q,r,s,t=[],u,v,w,x,y;
	function unify(x){// Convert x to unit vec
var i,s=0,x;
	for(i=0;i<3;i++){s+=x[i]*x[i]}
	s=M.sqrt(s)*(1+p.alt);
	for(i=0;i<3;i++){x[i]/=s;}
}
	// Make initial disc to occlude bottom hemisphere
	p=Pxob[0]; p.type=6; p.palette=[0.9,0.95,0.99];
	r=p.verts=[0,0,0]; p.num=102;p.r=1;
	function zlat(la,lo,r){
		var p=0.017453,a=p*la,b=p*lo,c=M.cos(a); 
		r.push(c*M.sin(b),M.sin(a),-c*M.cos(b));
	}
	for(i=0;i<361;i+=3.6){ zlat(i,90,r);}
	// Do lookups to make vertex arrays from data with links
	for(ii=1;ii<Pxno;ii++){
		p=Pxob[ii];
		q=p.links; 
		r=p.nodes;
		v=p.verts=[]; 
		p.num=0; 
		y=p.cols; 
		x=p.palette;
		m=r.length;
		if(!r)continue;
		// Look up pointers and expand lines (~great circles)
			for(i=0;i<m;i++){
			if(r[i]>1 | r[i]< -1){//Lat/lon
				s=[];
				for(j=0;j<m;j+=2){zlat(r[j],r[j+1],s);}
				r=s; break;
			}
			if(i>99)break;
			}
			m=q.length;
			o=m==0;if(o)m=r.length/3;
			for(j=0;j<m;j++){// loop over nodes or pointers
			s=(o?j:q[j])*3;// If links provided, lookup
			u=t.concat();
			t=[r[s],r[s+1],r[s+2]];//r=nodes
			if(p.type==LINE_STRIP+99){//great circles
			{
				if(j==0)continue;
				s=0;if(j>0)for(k=0;k<3;k++)s+=(u[k]-t[k])*(u[k]-t[k]);
				s=0.9999/M.ceil(M.sqrt(s)*5); 
				if(isNaN(s)){	s=2;u=t.concat();	}
				for(i=0;i<1;i+=s){
					w=[];
					for(k=0;k<3;k++)w.push(u[k]*(1-i)+i*t[k]);
					unify(w);
					v.push(w[0],w[1],w[2]); p.num++;
				}
				}
			} else{		// copy with any lookup onto .vert[]		
				if(t[2]!=0)unify(t);
				v.push(t[0],t[1],t[2]); p.num++;
				if(y){  // Look up and copy colors y (shading)
				k=y[s/3]*3;//pointer into palette x
				v.push(x[k],x[k+1],x[k+2],1);
				a=[k/3,t[1],(t[1]+1)*128]
				}// end copy to vert
			}
		}
		if(p.tags){Pxtg=p.nodes;Pxtx=p.tags;}
		if(v=p.scale){
			q=Pxob[Pxno++]; q.type=4; r=q.nodes=[]; 
			q.palette=x.concat(); y=q.cols=[0,0];q.r=2;
			d=v.length;b=286/(d-1);
			for(i=0;i<d;i++){
				c=document.createElement("span")
				Pxe[2].appendChild(c);
				c.style.position="absolute";
				c.style.top=(794-b*i)+"px";
				c.style.left="800px";
				c.innerHTML="_"+v[i];
			}
			d=x.length/3; b=.7/d;
			for(i=0;i<d;i++){y.push(i,i);
			r.push(.96,i*b-1,0,0.99,i*b-1,0);}
			}
	}// end ii loop
}
function PxOr(){//Orientation calc - mult rotation matrix.
var i,j,p,u,v,w;
	u=PxaM;  p=u[0]; w=Math.sqrt(p[3]*p[3]+p[4]*p[4]);
	v=[p[3]/w,p[4]/w]
	for(i=0;i<9;i+=3){
		w=p[i]; 
		p[i]=v[1]*w-v[0]*p[i+1];
		p[i+1]=v[0]*w+v[1]*p[i+1];
	}
PxDraw();
}
function PxNew(){//Enters new grid data and draws
var u,p;
	u=Pxe[4].value;
	p=u.length;
	p=Pxgr; p.m=0;
	if(!Pxgr | u.length<9)return;
	try{eval("p.nodes=["+u+"];")}
	catch(err){alert("Error in input data\n Error description: " + err.message + "\n\n");}
	p.links=1;
	p.title=Pxe[6].value;
	PxInit();
}
Pxold=0;
function PxInit(){
/* Sets globals, gets canvas element and GL context, constructs data objects, runs PxDat (defined on JS data file), and PxGeo to convert this to forms required by webGL. 
Compiles and attaches shaders, and does initial draw.
 Defines canvas callback functions.*/
var i,j,k,p,q,r,s,gl,cv;
if(!Pxold){//globals  
	Pxob=[];
	Pxxy=[];  
	Pxdrag=0; Pxzoom=1; 
	PxaM=[];
	for(i=0;i<3;i++)PxaM[i]=[1,0,0,0,1,0,0,0,1];	
	POINTS=0; LINES=1; TRIANGLES=2; LINE_STRIP=3; TRIANGLE_STRIP=4;MAP=7;
	Pxmax=100; // Max data objects
	Pxtg=0;	Pxis=-1
  PxD = [800,800];
	Pxsh=[	// Code for shaders
	["uniform mat3 aMX; attribute vec3 aPX; uniform float aSX;   void main() {  gl_Position = vec4(aMX * aPX,1); gl_PointSize = aSX;}",
	"precision mediump float; uniform vec4 aCX; void main() {  gl_FragColor = aCX;}"],
	["attribute vec3 aPX; 	attribute vec4 aCX; 	uniform mat3 aMX; varying vec4 vCX; 	void main() {gl_Position = vec4(aMX * aPX,1.); vCX=aCX;}",
	"precision highp float; varying vec4 vCX; void main() {	  gl_FragColor = vCX;}"]]
	Pxe=[]; for(i=0;i<8;i++)Pxe[i]=document.getElementById("Px"+i);
	cv=Pxcanvas=Pxe[0]; 
	Pxcn = Pxe[3].getContext("2d");
	gl = Pxgl = cv.getContext("webgl") || cv.getContext("experimental-webgl");

	for(i=0;i<Pxmax;i++){
		p=Pxob[i]={};
		p.links=[]; p.type=p.nodes=p.num=p.tags=p.alt=p.cols=p.scale=p.m=0;p.size=3;p.title="";p.palette=[0,0,0];
	}
		{ // Canvas functions
	   cv.onmousedown = function ( ev ){
		 var i,j,k=0,m,p,r=[0,0,0],x,s=[],u,a,b,c;
	     Pxdrag = [1,3,2][ev.button];
	     x=Pxxy[1] = Pxpix2z(ev); 
			 if(Pxdrag==1 & !(Pxtg==0)){//Finds nearest node
				// First rotate back to ref
				for(i=0;i<3;i++)for(j=0;j<3;j++)r[i]+=PxaM[0][3*i+j]*x[j];
				p=Pxtg;a=9;
				for(i=0;i<p.length;i++){
					b=0;for(j=0;j<3;j++){s=p[i*3+j]-r[j];b+=s*s;}
					if(b<a){k=i;a=b;}
				} // k is node number
				Pxe[1].innerHTML=Pxtx[k];
			 				
			 }
	    }
		 cv.onmouseup = function ( ev ){
			Pxdrag=0; PxDraw();
		 }
	   cv.onmouseout = cv.onmouseup;
		 
	   cv.onmousemove = function ( ev ){
		 var i,j,s,v,dr,cr,u,r=Pxxy;
	   if ( Pxdrag == 0 ) return;
			r[0]=r[1]; r[1]=Pxpix2z(ev);
			if(Pxdrag==2){Pxzoom *= 1+r[1][1]-r[0][1];}
			else if(Pxdrag==1){  // Trackball drag
			for(i=0;i<2;i++)if(isNaN(r[0][i]+r[1][i]))return;
				for(j=0;j<2;j++){
					dr=r[1][j]-r[0][j]; 
					cr=Math.sqrt(1-dr*dr)-1;
					for(i=0;i<9;i+=3){ //Change rotation matrix
						u=PxaM[0];s=u[i+j];v=u[i+2];
						u[i+j]+=cr*s-dr*v;  u[i+2]+=cr*v+dr*s;
					}
				}}
			PxDraw();
	   }
	}
	PxDat(Pxob); // Enter supplied data
	} // End startup seq
	gl=Pxgl; 
	Pxno=1; for(i=0;i<Pxmax;i++) {
		p=Pxob[i]; p.r=0; 
		if(p.type==MAP){
		p.nodes=Pxmap;p.type=LINE_STRIP;
		}
		q=p.nodes; if(q)Pxno++;
		if(p.links>0)PxGrid(p.links,q.length,p);
		if(p.scale){is=i;}
	}// Count objects with data
	PxGeo(); //Make data structures
	q="";
	for(i=0;i<Pxno;i++){
			 p=Pxob[i];  q+=p.title;
			 s=Pxsh[p.cols==0?0:1];  k=[];
			 for(j=0;j<2;j++)k[j]=s[j].replace(/X/g,i)
		   p.prog  = shadProg(gl, k);
	}
	Pxe[5].innerHTML=q;
	Pxold=1;  PxDraw();
}
PxInit();
